--- old/CHANGELOG	2017-04-12 16:50:33.223293674 -0700
+++ new/CHANGELOG	2017-05-25 12:43:49.165410451 -0700
@@ -9,3 +9,9 @@
 2017-04-12: 2.4: Changed behavior of mul() when sizeof(long)==sizeof(long long).
                  Compensated for recent brain damage in GCC.
 
+2017-05-25: 2.5: Removed extraneous lines from Makefile.
+                 Fixed disassemble-print for opcodes like (pop . 1).
+                 Fixed typo and reduced max line length in documentation.txt.
+                 Fixed (loop (catch #f (catch #f (exit-loop) #f) #f)).
+                 Changed macro-doublequote to support \x[0-9A-Fa-f][0-9A-Fa-f].
+
--- old/Makefile	2017-04-12 16:48:18.755288222 -0700
+++ new/Makefile	2017-05-17 20:43:29.481586982 -0700
@@ -15,7 +15,7 @@
 # Has targets related to building tarballs, etc.
 -include .local.Makefile
 
-$(BUILDDIR)mikelisp : $(SRCS:%.c=$(BUILDDIR)%.o) opcodes.c lisp.h $(DYNSRCS:%.c=$(BUILDDIR)%.mikelisp)
+$(BUILDDIR)mikelisp : $(SRCS:%.c=$(BUILDDIR)%.o) opcodes.c lisp.h
 	$(CC) $(CFLAGS) -o $@ $(SRCS:%.c=$(BUILDDIR)%.o) $(LIBS)
 
 $(BUILDDIR)preload.o : preload.c lisp.h $(LISPS:%.lisp=$(BUILDDIR)%.c)
@@ -27,9 +27,6 @@
 $(BUILDDIR)%.o : %.c lisp.h
 	$(CC) $(CFLAGS) -c -o $@ $<
 
-$(BUILDDIR)%.mikelisp : %.c lisp.h
-	$(CC) $(CFLAGS) $(DYNCFLAGS) -o $@ $<
-
 opcodes.c : vm.h
 	perl -ne 'print "\tADD_OP(\"".lc($$2)."\",$$1);\n" if(/#define (OP_([A-Z]+)) /)' vm.h | tac > opcodes.c2
 	mv opcodes.c2 opcodes.c
@@ -39,5 +36,5 @@
 	mv $(BUILDDIR)$*.c2 $(BUILDDIR)$*.c
 
 clean :
-	rm -f $(BUILDDIR)mikelisp $(BUILDDIR)*.o $(BUILDDIR)*.mikelisp
+	rm -f $(BUILDDIR)mikelisp $(BUILDDIR)*.o
 
--- old/compiler.lisp	2010-08-12 14:55:19.000000000 -0700
+++ new/compiler.lisp	2017-05-24 15:57:51.908892070 -0700
@@ -1,4 +1,4 @@
-; compiler.lisp   by Michael Thorpe   2010-08-12
+; compiler.lisp   by Michael Thorpe   2017-05-24
 
 (define (opcode-to-byte opcode)
 	(let ((val (get #vm-opcodes opcode)))
@@ -61,12 +61,12 @@
 	#f)
 
 ; Numeric comparison opcodes
-(define (byte-compile-numeric-comparison code stackitems loopheight arg)
-	(if byte-compile-debug (dprint 'byte-compile-numeric-comparison code stackitems loopheight arg))
+(define (byte-compile-numeric-comparison code stackitems flowstack arg)
+	(if byte-compile-debug (dprint 'byte-compile-numeric-comparison code stackitems flowstack arg))
 	(if (<> 3 (list-length code)) (throw 'argument-error code))
 	(append
-		(byte-compile-helper (cadr code) stackitems loopheight)
-		(byte-compile-helper (caddr code) (cons #f stackitems) loopheight)
+		(byte-compile-helper (cadr code) stackitems flowstack)
+		(byte-compile-helper (caddr code) (cons #f stackitems) flowstack)
 		`((cmp . ,arg))))
 (define (byte-compile-lt c s l)
 	(byte-compile-numeric-comparison c s l 1))
@@ -88,12 +88,12 @@
 (function-compiler '>= byte-compile-ge)
 
 ; Basic two-argument opcodes
-(define (byte-compile-basic-two-op code stackitems loopheight opcode)
-	(if byte-compile-debug (dprint 'byte-compile-basic-two-op code stackitems loopheight opcode))
+(define (byte-compile-basic-two-op code stackitems flowstack opcode)
+	(if byte-compile-debug (dprint 'byte-compile-basic-two-op code stackitems flowstack opcode))
 	(if (<> 3 (list-length code)) (throw 'argument-error code))
 	(append
-		(byte-compile-helper (cadr code) stackitems loopheight)
-		(byte-compile-helper (caddr code) (cons #f stackitems) loopheight)
+		(byte-compile-helper (cadr code) stackitems flowstack)
+		(byte-compile-helper (caddr code) (cons #f stackitems) flowstack)
 		`((,opcode . 0))))
 (define (byte-compile-add c s l)
 	(byte-compile-basic-two-op c s l 'add))
@@ -118,11 +118,11 @@
 (function-compiler '>> byte-compile-asr)
 
 ; Basic one-argument opcodes
-(define (byte-compile-basic-one-op code stackitems loopheight opcode)
-	(if byte-compile-debug (dprint 'byte-compile-basic-one-op code stackitems loopheight opcode))
+(define (byte-compile-basic-one-op code stackitems flowstack opcode)
+	(if byte-compile-debug (dprint 'byte-compile-basic-one-op code stackitems flowstack opcode))
 	(if (<> 2 (list-length code)) (throw 'argument-error code))
 	(append
-		(byte-compile-helper (cadr code) stackitems loopheight)
+		(byte-compile-helper (cadr code) stackitems flowstack)
 		`((,opcode . 0))))
 (define (byte-compile-car c s l)
 	(byte-compile-basic-one-op c s l 'car))
@@ -146,24 +146,24 @@
 	(byte-compile-basic-one-op c s l 'undefine))
 (function-compiler 'undefine byte-compile-undefine)
 
-(define (byte-compile-and code stackitems loopheight)
-	(if byte-compile-debug (dprint 'byte-compile-and code stackitems loopheight))
+(define (byte-compile-and code stackitems flowstack)
+	(if byte-compile-debug (dprint 'byte-compile-and code stackitems flowstack))
 	(if (<> 3 (list-length code)) (throw 'argument-error code))
-	(let ((b (byte-compile-helper (unquote (caddr code)) stackitems loopheight)))
+	(let ((b (byte-compile-helper (unquote (caddr code)) stackitems flowstack)))
 		(append
-			(byte-compile-helper (cadr code) stackitems loopheight)
+			(byte-compile-helper (cadr code) stackitems flowstack)
 			`((index . 0))
 			`((bf . ,(+ 1 (list-length b))))
 			`((pop . 0))
 			b)))
 (function-compiler '#and byte-compile-and)
 
-(define (byte-compile-append/reversed code stackitems loopheight)
-	(if byte-compile-debug (dprint 'byte-compile-append/reversed code stackitems loopheight))
+(define (byte-compile-append/reversed code stackitems flowstack)
+	(if byte-compile-debug (dprint 'byte-compile-append/reversed code stackitems flowstack))
 	(if (<> 3 (list-length code)) (throw 'argument-error code))
 	(append
-		(byte-compile-helper (cadr code) stackitems loopheight)
-		(byte-compile-helper (caddr code) (cons #f stackitems) loopheight)
+		(byte-compile-helper (cadr code) stackitems flowstack)
+		(byte-compile-helper (caddr code) (cons #f stackitems) flowstack)
 ; If the list to be reversed is empty, skip all the processing
 		`((index . 0))
 		`((bf . 8))
@@ -179,49 +179,49 @@
 		`((pop . 0))))
 (function-compiler '#append/reversed byte-compile-append/reversed)
 
-(define (byte-compile-bit-select code stackitems loopheight)
-	(if byte-compile-debug (dprint 'byte-compile-bit-select code stackitems loopheight))
+(define (byte-compile-bit-select code stackitems flowstack)
+	(if byte-compile-debug (dprint 'byte-compile-bit-select code stackitems flowstack))
 	(if (<> 4 (list-length code)) (throw 'argument-error code))
 	(append
-		(byte-compile-helper (cadr code) stackitems loopheight)
-		(byte-compile-helper (caddr code) (cons #f stackitems) loopheight)
-		(byte-compile-helper (cadddr code) (cons #f (cons #f stackitems)) loopheight)
+		(byte-compile-helper (cadr code) stackitems flowstack)
+		(byte-compile-helper (caddr code) (cons #f stackitems) flowstack)
+		(byte-compile-helper (cadddr code) (cons #f (cons #f stackitems)) flowstack)
 		`((bitsel . 0))))
 (function-compiler 'bit-select byte-compile-bit-select)
-(define (byte-compile-bit-not code stackitems loopheight)
-	(if byte-compile-debug (dprint 'byte-compile-bit-not code stackitems loopheight))
+(define (byte-compile-bit-not code stackitems flowstack)
+	(if byte-compile-debug (dprint 'byte-compile-bit-not code stackitems flowstack))
 	(if (<> 2 (list-length code)) (throw 'argument-error code))
 	(append
-		(byte-compile-helper (cadr code) stackitems loopheight)
-		(byte-compile-helper -1 (cons #f stackitems) loopheight)
-		(byte-compile-helper 0 (cons #f (cons #f stackitems)) loopheight)
+		(byte-compile-helper (cadr code) stackitems flowstack)
+		(byte-compile-helper -1 (cons #f stackitems) flowstack)
+		(byte-compile-helper 0 (cons #f (cons #f stackitems)) flowstack)
 		`((bitsel . 0))))
 (function-compiler 'bit-not byte-compile-bit-not)
-(define (byte-compile-bit-and code stackitems loopheight)
-	(if byte-compile-debug (dprint 'byte-compile-bit-and code stackitems loopheight))
+(define (byte-compile-bit-and code stackitems flowstack)
+	(if byte-compile-debug (dprint 'byte-compile-bit-and code stackitems flowstack))
 	(if (<> 3 (list-length code)) (throw 'argument-error code))
 	(append
-		(byte-compile-helper (cadr code) stackitems loopheight)
-		(byte-compile-helper 0 (cons #f stackitems) loopheight)
-		(byte-compile-helper (caddr code) (cons #f (cons #f stackitems)) loopheight)
+		(byte-compile-helper (cadr code) stackitems flowstack)
+		(byte-compile-helper 0 (cons #f stackitems) flowstack)
+		(byte-compile-helper (caddr code) (cons #f (cons #f stackitems)) flowstack)
 		`((bitsel . 0))))
 (function-compiler 'bit-and byte-compile-bit-and)
-(define (byte-compile-bit-or code stackitems loopheight)
-	(if byte-compile-debug (dprint 'byte-compile-bit-or code stackitems loopheight))
+(define (byte-compile-bit-or code stackitems flowstack)
+	(if byte-compile-debug (dprint 'byte-compile-bit-or code stackitems flowstack))
 	(if (<> 3 (list-length code)) (throw 'argument-error code))
 	(append
-		(byte-compile-helper (cadr code) stackitems loopheight)
-		(byte-compile-helper (caddr code) (cons #f stackitems) loopheight)
-		(byte-compile-helper -1 (cons #f (cons #f stackitems)) loopheight)
+		(byte-compile-helper (cadr code) stackitems flowstack)
+		(byte-compile-helper (caddr code) (cons #f stackitems) flowstack)
+		(byte-compile-helper -1 (cons #f (cons #f stackitems)) flowstack)
 		`((bitsel . 0))))
 (function-compiler 'bit-or byte-compile-bit-or)
 
-(define (byte-compile-bit-xor code stackitems loopheight)
-	(if byte-compile-debug (dprint 'byte-compile-bit-xor code stackitems loopheight))
+(define (byte-compile-bit-xor code stackitems flowstack)
+	(if byte-compile-debug (dprint 'byte-compile-bit-xor code stackitems flowstack))
 	(if (<> 3 (list-length code)) (throw 'argument-error code))
 	(append
-		(byte-compile-helper (cadr code) stackitems loopheight)
-		(byte-compile-helper (caddr code) (cons #f stackitems) loopheight)
+		(byte-compile-helper (cadr code) stackitems flowstack)
+		(byte-compile-helper (caddr code) (cons #f stackitems) flowstack)
 		`((index . 0))
 		`((pushi . -1))
 		`((pushi . 0))
@@ -229,20 +229,20 @@
 		`((bitsel . 0))))
 (function-compiler 'bit-xor byte-compile-bit-xor)
 
-(define (byte-compile-catch code stackitems loopheight)
-	(if byte-compile-debug (dprint 'byte-compile-catch code stackitems loopheight))
+(define (byte-compile-catch code stackitems flowstack)
+	(if byte-compile-debug (dprint 'byte-compile-catch code stackitems flowstack))
 	(if (<> 4 (list-length code)) (throw 'argument-error code))
 	(let ((type (cadr code))
 	      (trialcode (caddr code))
 	      (badcode (cadddr code)))
 		(if (eq? type '#f)
 			(set type #f))
-		(set trialcode (byte-compile-helper (unquote trialcode) stackitems loopheight))
-		(set badcode (byte-compile-helper (unquote badcode) stackitems loopheight))
+		(set trialcode (byte-compile-helper (unquote trialcode) stackitems (cons (cons 'catch #f) flowstack)))
+		(set badcode (byte-compile-helper (unquote badcode) stackitems flowstack))
 		(if type
 			(set badcode
 				(append
-					(byte-compile-helper type stackitems loopheight)
+					(byte-compile-helper type stackitems flowstack)
 					`((extype . 0))
 					`((eq . 0))
 					`((bt . 3))
@@ -258,12 +258,12 @@
 			badcode)))
 (function-compiler '#catch byte-compile-catch)
 
-(define (byte-compile-define code stackitems loopheight)
-	(if byte-compile-debug (dprint 'byte-compile-define code stackitems loopheight))
+(define (byte-compile-define code stackitems flowstack)
+	(if byte-compile-debug (dprint 'byte-compile-define code stackitems flowstack))
 	(if (<> 3 (list-length code)) (throw 'argument-error code))
 	(ifelse (quoted? (cadr code))
 		(let ((var (unquote (cadr code)))
-		      (val (byte-compile-helper (caddr code) stackitems loopheight)))
+		      (val (byte-compile-helper (caddr code) stackitems flowstack)))
 			(unless (eq? 'word (object-type var)) (throw 'argument-error code))
 			(let ((pos (list-index stackitems var)))
 				(ifelse pos
@@ -275,8 +275,8 @@
 						val
 						`((localobj . ,var))
 						`((define . 0))))))
-		(let ((val (byte-compile-helper (caddr code) stackitems loopheight))
-		      (var (byte-compile-helper (cadr code) (cons #f stackitems) loopheight)))
+		(let ((val (byte-compile-helper (caddr code) stackitems flowstack))
+		      (var (byte-compile-helper (cadr code) (cons #f stackitems) flowstack)))
 			(append
 				val
 				var
@@ -287,15 +287,15 @@
 ; Two loops are run:
 ;   The first filters the list into a new, reversed list
 ;   The second reverses the reversed list into the result
-(define (byte-compile-filter code stackitems loopheight)
-	(if byte-compile-debug (dprint 'byte-compile-filter code stackitems loopheight))
+(define (byte-compile-filter code stackitems flowstack)
+	(if byte-compile-debug (dprint 'byte-compile-filter code stackitems flowstack))
 	(if (<> 4 (list-length code)) (throw 'argument-error code))
 	(unless (quoted? (cadr code)) (throw 'argument-error code))
 	(let ((var (unquote (cadr code)))
-	      (filter (byte-compile-helper (unquote (caddr code)) (cons var (cons #f (cons #f stackitems))) loopheight)))
+	      (filter (byte-compile-helper (unquote (caddr code)) (cons var (cons #f (cons #f stackitems))) flowstack)))
 		(unless (word? var) (throw 'argument-error code))
 		(append
-	      (byte-compile-helper (cadddr code) stackitems loopheight)
+	      (byte-compile-helper (cadddr code) stackitems flowstack)
 ; If the list is empty, skip all the processing
 			`((index . 0))
 			`((bf . ,(+ 3 (list-length filter) 20)))
@@ -331,37 +331,37 @@
 			`((pop . 0)))))
 (function-compiler '#filter byte-compile-filter)
 
-(define (byte-compile-ifelse code stackitems loopheight)
-	(if byte-compile-debug (dprint 'byte-compile-ifelse code stackitems loopheight))
+(define (byte-compile-ifelse code stackitems flowstack)
+	(if byte-compile-debug (dprint 'byte-compile-ifelse code stackitems flowstack))
 	(if (<> 4 (list-length code)) (throw 'argument-error code))
-	(let ((iftrue (byte-compile-helper (unquote (caddr code)) stackitems loopheight))
-	      (iffalse (byte-compile-helper (unquote (cadddr code)) stackitems loopheight)))
+	(let ((iftrue (byte-compile-helper (unquote (caddr code)) stackitems flowstack))
+	      (iffalse (byte-compile-helper (unquote (cadddr code)) stackitems flowstack)))
 		(append
-			(byte-compile-helper (cadr code) stackitems loopheight)
+			(byte-compile-helper (cadr code) stackitems flowstack)
 			`((bf . ,(+ (list-length iftrue) 1)))
 			iftrue
 			`((goto . ,(list-length iffalse)))
 			iffalse)))
 (function-compiler '#ifelse byte-compile-ifelse)
 
-(define (byte-compile-let code stackitems loopheight)
-	(if byte-compile-debug (dprint 'byte-compile-let code stackitems loopheight))
+(define (byte-compile-let code stackitems flowstack)
+	(if byte-compile-debug (dprint 'byte-compile-let code stackitems flowstack))
 	(if (<> 4 (list-length code)) (throw 'argument-error code))
 	(let ((var (unquote (cadr code)))
-	      (val (byte-compile-helper (caddr code) stackitems loopheight))
+	      (val (byte-compile-helper (caddr code) stackitems flowstack))
 	      (subcode (cadddr code)))
 		(unless (eq? 'word (object-type var)) (throw 'argument-error code))
 		(append
 			val
-			(byte-compile-helper (unquote subcode) (cons var stackitems) loopheight)
+			(byte-compile-helper (unquote subcode) (cons var stackitems) flowstack)
 ; "Pop" the var location (which is currently under the topmost value)
 			`((put . 0)))))
 (function-compiler '#let byte-compile-let)
 
-(define (byte-compile-loop code stackitems loopheight)
-	(if byte-compile-debug (dprint 'byte-compile-loop code stackitems loopheight))
+(define (byte-compile-loop code stackitems flowstack)
+	(if byte-compile-debug (dprint 'byte-compile-loop code stackitems flowstack))
 	(if (<> 2 (list-length code)) (throw 'argument-error code))
-	(set code (byte-compile-helper (unquote (cadr code)) stackitems (list-length stackitems)))
+	(set code (byte-compile-helper (unquote (cadr code)) stackitems (cons (cons 'loop (list-length stackitems)) flowstack)))
 	(let ((rev ())
 	      (jumpdistance -1))
 ; Expand next-loop "opcodes"
@@ -384,26 +384,50 @@
 	code)
 (function-compiler '#loop byte-compile-loop)
 
-(define (byte-compile-exit-loop code stackitems loopheight)
-	(if byte-compile-debug (dprint 'byte-compile-exit-loop code stackitems loopheight))
+; Calculates how many pops and tosses we need to get back to the innermost loop
+(define (byte-compile-loop-assistant stackitems flowstack)
+	(let ((tosses 0))
+		(cons
+			(loop
+				(unless flowstack (throw 'assembler-error stackitems))
+				(if (eq? 'loop (caar flowstack))
+					(let ((extra (- (list-length stackitems) (cdar flowstack))))
+						(if (< extra 0) (throw 'assembler-error stackitems))
+						(exit-loop extra)))
+				(ifelse (eq? 'catch (caar flowstack))
+					(set tosses (+ tosses 1))
+					(throw 'assembler-error flowstack))
+				(set flowstack (cdr flowstack)))
+			tosses)))
+
+(define (byte-compile-exit-loop code stackitems flowstack)
+	(if byte-compile-debug (dprint 'byte-compile-exit-loop code stackitems flowstack))
 	(if (<> 2 (list-length code)) (throw 'argument-error code))
-	(let ((extra (- (list-length stackitems) loopheight))
-	      (revcode (reverse (byte-compile-helper (cadr code) stackitems loopheight))))
-		(if (< extra 0) (throw 'assembler-error code))
+	(let ((extra/tosses (byte-compile-loop-assistant stackitems flowstack))
+	      (extra (car extra/tosses))
+	      (tosses (cdr extra/tosses))
+	      (revcode (reverse (byte-compile-helper (cadr code) stackitems flowstack))))
 		(if (> extra 0)
 			(set revcode (cons `(put . ,(- extra 1)) revcode)))
 		(if (> extra 1)
 			(set revcode (cons `(pop . ,(- extra 2)) revcode)))
+		(while (> tosses 0)
+			(set revcode (cons `(toss . 0) revcode))
+			(set tosses (- tosses 1)))
 		(set revcode (cons `(exit-loop . #f) revcode))
 		(reverse revcode)))
 (function-compiler '#exit-loop byte-compile-exit-loop)
 
-(define (byte-compile-next-loop code stackitems loopheight)
-	(if byte-compile-debug (dprint 'byte-compile-next-loop code stackitems loopheight))
+(define (byte-compile-next-loop code stackitems flowstack)
+	(if byte-compile-debug (dprint 'byte-compile-next-loop code stackitems flowstack))
 	(if (<> 1 (list-length code)) (throw 'argument-error code))
-	(let ((extra (- (list-length stackitems) loopheight)))
-		(if (< extra 0) (throw 'assembler-error code))
+	(let ((extra/tosses (byte-compile-loop-assistant stackitems flowstack))
+	      (extra (car extra/tosses))
+	      (tosses (cdr extra/tosses)))
 		(set code `((next-loop . #f)))
+		(while (> tosses 0)
+			(set code (cons `(toss . 0) code))
+			(set tosses (- tosses 1)))
 		(if (> extra 0)
 			(set code (cons `(pop . ,(- extra 1)) code)))
 		code))
@@ -413,15 +437,15 @@
 ; Two loops are run:
 ;   The first maps the list into a new, reversed list
 ;   The second reverses the reversed list into the result
-(define (byte-compile-map code stackitems loopheight)
-	(if byte-compile-debug (dprint 'byte-compile-map code stackitems loopheight))
+(define (byte-compile-map code stackitems flowstack)
+	(if byte-compile-debug (dprint 'byte-compile-map code stackitems flowstack))
 	(if (<> 4 (list-length code)) (throw 'argument-error code))
 	(unless (quoted? (cadr code)) (throw 'argument-error code))
 	(let ((var (unquote (cadr code)))
-	      (mapper (byte-compile-helper (unquote (caddr code)) (cons var (cons #f (cons #f stackitems))) loopheight)))
+	      (mapper (byte-compile-helper (unquote (caddr code)) (cons var (cons #f (cons #f stackitems))) flowstack)))
 		(unless (word? var) (throw 'argument-error code))
 		(append
-	      (byte-compile-helper (cadddr code) stackitems loopheight)
+	      (byte-compile-helper (cadddr code) stackitems flowstack)
 ; If the list is empty, skip all the processing
 			`((index . 0))
 			`((bf . ,(+ 3 (list-length mapper) 17)))
@@ -455,15 +479,15 @@
 ;   (#map-safe 'a '(+ a 10) '(1 2 . 3))
 ; which will return:
 ;   (11 12 . 13)
-(define (byte-compile-map-safe code stackitems loopheight)
-	(if byte-compile-debug (dprint 'byte-compile-map-safe code stackitems loopheight))
+(define (byte-compile-map-safe code stackitems flowstack)
+	(if byte-compile-debug (dprint 'byte-compile-map-safe code stackitems flowstack))
 	(if (<> 4 (list-length code)) (throw 'argument-error code))
 	(unless (quoted? (cadr code)) (throw 'argument-error code))
 	(let ((var (unquote (cadr code)))
-	      (mapper (byte-compile-helper (unquote (caddr code)) (cons var (cons #f (cons #f stackitems))) loopheight)))
+	      (mapper (byte-compile-helper (unquote (caddr code)) (cons var (cons #f (cons #f stackitems))) flowstack)))
 		(unless (word? var) (throw 'argument-error code))
 		(append
-	      (byte-compile-helper (cadddr code) stackitems loopheight)
+	      (byte-compile-helper (cadddr code) stackitems flowstack)
 ; If the list is empty, skip all the processing
 			`((index . 0))
 			`((bf . ,(+ 3 (list-length mapper) 12 (list-length mapper) 11)))
@@ -502,50 +526,50 @@
 			`((pop . 0)))))
 (function-compiler '#map-safe byte-compile-map-safe)
 
-(define (byte-compile-or code stackitems loopheight)
-	(if byte-compile-debug (dprint 'byte-compile-or code stackitems loopheight))
+(define (byte-compile-or code stackitems flowstack)
+	(if byte-compile-debug (dprint 'byte-compile-or code stackitems flowstack))
 	(if (<> 3 (list-length code)) (throw 'argument-error code))
-	(let ((b (byte-compile-helper (unquote (caddr code)) stackitems loopheight)))
+	(let ((b (byte-compile-helper (unquote (caddr code)) stackitems flowstack)))
 		(append
-			(byte-compile-helper (cadr code) stackitems loopheight)
+			(byte-compile-helper (cadr code) stackitems flowstack)
 			`((index . 0))
 			`((bt . ,(+ 1 (list-length b))))
 			`((pop . 0))
 			b)))
 (function-compiler '#or byte-compile-or)
 
-(define (byte-compile-prog1of2 code stackitems loopheight)
-	(if byte-compile-debug (dprint 'byte-compile-prog1of2 code stackitems loopheight))
+(define (byte-compile-prog1of2 code stackitems flowstack)
+	(if byte-compile-debug (dprint 'byte-compile-prog1of2 code stackitems flowstack))
 	(if (<> 3 (list-length code)) (throw 'argument-error code))
 	(append
-		(byte-compile-helper (cadr code) stackitems loopheight)
-		(byte-compile-helper (caddr code) (cons #f stackitems) loopheight)
+		(byte-compile-helper (cadr code) stackitems flowstack)
+		(byte-compile-helper (caddr code) (cons #f stackitems) flowstack)
 		`((pop . 0))))
 (function-compiler '#prog1of2 byte-compile-prog1of2)
 
-(define (byte-compile-prog2of2 code stackitems loopheight)
-	(if byte-compile-debug (dprint 'byte-compile-prog2of2 code stackitems loopheight))
+(define (byte-compile-prog2of2 code stackitems flowstack)
+	(if byte-compile-debug (dprint 'byte-compile-prog2of2 code stackitems flowstack))
 	(if (<> 3 (list-length code)) (throw 'argument-error code))
 	(append
-		(byte-compile-helper (cadr code) stackitems loopheight)
+		(byte-compile-helper (cadr code) stackitems flowstack)
 		`((pop . 0))
-		(byte-compile-helper (unquote (caddr code)) stackitems loopheight)))
+		(byte-compile-helper (unquote (caddr code)) stackitems flowstack)))
 (function-compiler '#prog2of2 byte-compile-prog2of2)
 
-(define (byte-compile-quote code stackitems loopheight)
-	(if byte-compile-debug (dprint 'byte-compile-quote code stackitems loopheight))
+(define (byte-compile-quote code stackitems flowstack)
+	(if byte-compile-debug (dprint 'byte-compile-quote code stackitems flowstack))
 	(if (<> 2 (list-length code)) (throw 'argument-error code))
 	(append
-		(byte-compile-helper (cadr code) stackitems loopheight)
+		(byte-compile-helper (cadr code) stackitems flowstack)
 		`((quote . 0))))
 (function-compiler 'quote byte-compile-quote)
 
-(define (byte-compile-set code stackitems loopheight)
-	(if byte-compile-debug (dprint 'byte-compile-set code stackitems loopheight))
+(define (byte-compile-set code stackitems flowstack)
+	(if byte-compile-debug (dprint 'byte-compile-set code stackitems flowstack))
 	(if (<> 3 (list-length code)) (throw 'argument-error code))
 	(ifelse (quoted? (cadr code))
 		(let ((var (unquote (cadr code)))
-		      (val (byte-compile-helper (caddr code) stackitems loopheight)))
+		      (val (byte-compile-helper (caddr code) stackitems flowstack)))
 			(unless (word? var) (throw 'argument-error code))
 			(let ((pos (list-index stackitems var)))
 				(ifelse pos
@@ -559,45 +583,45 @@
 						`((set . 0))))))
 ; set is "backwards" (the opcode takes value then var)
 		(append
-			(byte-compile-helper (caddr code) stackitems loopheight)
-			(byte-compile-helper (cadr code) (cons #f stackitems) loopheight)
+			(byte-compile-helper (caddr code) stackitems flowstack)
+			(byte-compile-helper (cadr code) (cons #f stackitems) flowstack)
 			`((set . 0)))))
 (function-compiler '#set byte-compile-set)
 
-(define (byte-compile-throw code stackitems loopheight)
-	(if byte-compile-debug (dprint 'byte-compile-throw code stackitems loopheight))
+(define (byte-compile-throw code stackitems flowstack)
+	(if byte-compile-debug (dprint 'byte-compile-throw code stackitems flowstack))
 	(if (<> 3 (list-length code)) (throw 'argument-error code))
 ; throw is "backwards" (the opcode takes value then type)
 	(append
-		(byte-compile-helper (caddr code) stackitems loopheight)
-		(byte-compile-helper (cadr code) (cons #f stackitems) loopheight)
+		(byte-compile-helper (caddr code) stackitems flowstack)
+		(byte-compile-helper (cadr code) (cons #f stackitems) flowstack)
 		`((throw . 0))))
 (function-compiler 'throw byte-compile-throw)
 
-(define (byte-compile-unquote code stackitems loopheight)
-	(if byte-compile-debug (dprint 'byte-compile-unquote code stackitems loopheight))
+(define (byte-compile-unquote code stackitems flowstack)
+	(if byte-compile-debug (dprint 'byte-compile-unquote code stackitems flowstack))
 	(if (<> 2 (list-length code)) (throw 'argument-error code))
 	(append
-		(byte-compile-helper (cadr code) stackitems loopheight)
+		(byte-compile-helper (cadr code) stackitems flowstack)
 		`((unquote . 0))))
 (function-compiler 'unquote byte-compile-unquote)
 
-(define (byte-compile-helper-unknown-function code stackitems loopheight)
-	(if byte-compile-debug (dprint 'byte-compile-helper-unknown-function code stackitems loopheight))
+(define (byte-compile-helper-unknown-function code stackitems flowstack)
+	(if byte-compile-debug (dprint 'byte-compile-helper-unknown-function code stackitems flowstack))
 	(let ((args (cdr code))
 	      (instructions #f)
 	      (numargs (list-length args)))
 		(while args
-			(set instructions (append instructions (byte-compile-helper (car args) stackitems loopheight)))
+			(set instructions (append instructions (byte-compile-helper (car args) stackitems flowstack)))
 			(set args (cdr args))
 			(set stackitems (cons #f stackitems)))
 		(append
 			instructions
-			(byte-compile-helper (car code) stackitems loopheight)
+			(byte-compile-helper (car code) stackitems flowstack)
 			`((call . ,numargs)))))
 
-(define (byte-compile-helper code stackitems loopheight)
-	(if (and byte-compile-debug (neq? 'cons (object-type code))) (dprint 'byte-compile-helper code stackitems loopheight))
+(define (byte-compile-helper code stackitems flowstack)
+	(if (and byte-compile-debug (neq? 'cons (object-type code))) (dprint 'byte-compile-helper code stackitems flowstack))
 	(switch (object-type code)
 		(('word)
 			(let ((pos (list-index stackitems code)))
@@ -612,13 +636,13 @@
 		(('cons)
 			(let ((helper (get #function-compilers (car code))))
 				(ifelse helper
-					(helper code stackitems loopheight)
-					(byte-compile-helper-unknown-function code stackitems loopheight))))
+					(helper code stackitems flowstack)
+					(byte-compile-helper-unknown-function code stackitems flowstack))))
 		(('quote)
 			(set code (unquote code))
 			(ifelse code
 				(ifelse (eq? (object-type code) 'integer)
-					(byte-compile-helper code stackitems loopheight)
+					(byte-compile-helper code stackitems flowstack)
 					`((localobj . ,code)))
 				`((nil . 0))))
 		(('integer)
@@ -840,7 +864,9 @@
 					(write-object file op)
 					(switch op
 						(('nil 'pop 'exch 'add 'sub 'mul 'div 'toss 'throw 'define 'lookup 'set 'evaluate 'extype 'exvalue 'eq 'and 'or 'not 'objtype 'cons 'car 'cdr 'quote 'unquote 'bitsel 'asr)
-							#f)
+							(unless (= 0 arg)
+								(write-string file " ")
+								(write-object file arg)))
 						(else
 							(write-string file " ")
 							(if (and (eq? 'localobj op) (word? arg))
--- old/functions.lisp	2010-08-12 14:56:31.000000000 -0700
+++ new/functions.lisp	2017-05-24 16:03:59.020887692 -0700
@@ -1,4 +1,4 @@
-; functions.lisp   by Michael Thorpe   2010-08-12
+; functions.lisp   by Michael Thorpe   2017-05-24
 
 (define (pair? o)
 	(eq? (object-type o) 'cons))
@@ -92,6 +92,16 @@
 (define (is-ascii c) ; space through tilde
 	(and (< 31 c) (< c 127)))
 
+; Returns the value of the hexchar, or #f if it's not a hexchar
+(define (hexchar? c)
+	(ifelse (and (<= 48 c) (<= c 57))
+		(- c 48)
+		(ifelse (and (<= 65 c) (<= c 70))
+			(- c 55)
+			(ifelse (and (<= 97 c) (<= c 102))
+				(- c 87)
+				#f))))
+
 ; Skips whitespace and returns the peek-char of the character after that.
 ; Skips over comments as if they were whitespace.
 (define (skip-whitespace stream)
@@ -178,8 +188,26 @@
 			(throw 'reader-error stream))))
 (define-character-macro 96 macro-backtick)
 
+(define (subsubmacro-doublequote-backslash-x stream)
+	(let ((c (hexchar? (catch 'end-of-file (peek-char stream) (throw 'reader-error stream)))))
+		(unless c (throw 'reader-error stream))
+		(read-char stream)
+		(catch 'end-of-file
+			(let ((c2 (hexchar? (peek-char stream))))
+				(if c2
+					(read-char stream)
+					(set c (+ (* c 16) c2))))
+			#f)
+		c))
+
+(define (submacro-doublequote-backslash stream)
+	(let ((c (catch 'end-of-file (read-char stream) (throw 'reader-error stream))))
+		(ifelse (= 120 c) ; x
+			(subsubmacro-doublequote-backslash-x stream)
+			c)))
+
 (define (macro-doublequote stream)
-	(let ((c 0)
+	(let ((c #f)
 	      (i 0)
 	      (string (new-string 512)))
 		(loop
@@ -192,10 +220,7 @@
 			(if (= c 34) ; 34 = ASCII double quote
 				(exit-loop))
 			(if (= c 92) ; 92 = ASCII backslash
-				(set c 
-					(catch 'end-of-file
-						(read-char stream)
-						(throw 'reader-error stream))))
+				(set c (submacro-doublequote-backslash stream)))
 			(put-char string i c)
 			(set i (+ i 1)))
 		(substring string 0 i)))
